#define F_CPU 16000000
#define true 1
#define TEMP_CH 7
#define LIGHT_CH 6

#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>

int i;

int uart_putchar(char c, FILE *unused);
FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, NULL, _FDEV_SETUP_WRITE);

int uart_putchar(char c, FILE *unused)
{
  if (c == '\n')
      uart_putchar('\r', 0);
  loop_until_bit_is_set(UCSRA, UDRE);
  UDR = c;
  return 0;
}

void init_ADC(){
  ADCSRA = 0;
  ADMUX  = (1 << REFS0);
  ADCSRA = ( (1 << ADEN) | (1 << ADATE ) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0));
}

unsigned int get_ADC(uint8_t channel){

  ADMUX  |= channel;
  ADCSRA |= 1<<ADSC;
  while(!(ADCSRA & (1<<ADIF)));

  return ADC;
  }
  
void USART_init(void)
{
  UCSRB |= ((1<<RXEN) | (1<<TXEN));
  UBRRL = 0x67;
  UCSRC |= ((1<<URSEL) | (1<<UCSZ1) | (1<<UCSZ0));
}


int main(){
  int temp, light;

  init_ADC();
  USART_init();
  stdout = &mystdout;

  _delay_ms(1000);
  
  while(true){

    init_ADC();
    
    temp = 0;
    for(i = 0; i <=5 2; i++){
      if(i){
	      //Nu ia in calcul prima citire, fiindca e irelevanta
	      temp += (get_ADC(TEMP_CH)/2);
	  }
      _delay_ms(5);
    } 
    printf("T:%4d\n", temp/50); //afisam valoarea citita 
    
    _delay_ms(500);

    init_ADC();

    light = 0;
    for(i=0;i<=50;i++){
      if(i){
	      //Nu ia in calcul prima citire, fiindca e irelevanta
	      light += (get_ADC(LIGHT_CH)/5);
	  }
       _delay_ms(5);
    }
    printf("L:%4d\n", light/50); //afisam valoarea citita
    
    _delay_ms(1000);
  }

  return 0;
}

